diff --git a/dev-libs/libQtOlm/Manifest b/dev-libs/libQtOlm/Manifest
new file mode 100644
index 0000000..d0b70f6
--- /dev/null
+++ b/dev-libs/libQtOlm/Manifest
@@ -0,0 +1,3 @@
+DIST libqtolm-v3.0.1.tar.gz 23507 BLAKE2B 9b5279020fa8c8fac21690fb184357614d411db4fd89e8ad83896fe1ee80078a220d229269935fb7ff24f9eddb92e733ad88cb52ac7ae88f2aa27e23dcb1db5b SHA512 98ee8f1a9f69e6e78105e9deb651d276de79678f749d43ae506295d59500617ce517338894a96a163e6d2de901413d6200bb788b507a6ad9179e1cbdc682a858
+EBUILD libQtOlm-3.0.1.ebuild 769 BLAKE2B 9a4683cac477e2eda728cc9565838bd919ddead385b41413b39ab1433044b643e77392e9698b976678f5ea9c87cf1f370302bb7ccd5638a7509494b44ac8a3c6 SHA512 3e2c4a37b47e7224c58ac3f662597fdcb7c9ba1ae46a375ea8c8d6cef7eb7482c2a6844a1c30d9a05d258f0d933b58dec9a2b80269cb6e47464d874c290e22a0
+EBUILD libQtOlm-9999.ebuild 564 BLAKE2B 99fd33be45e4a425bbc01a3e7951f1064aa6952cf8cdf5f4f9a5b6470441d16fffc1370abce8e673da6c50d29c4c716559582473aa403af105b4a1c88b6a98c3 SHA512 ac6f0c642fc9d48e1490f9fb8820691ee30d7bd8faf77399704321f297eb334d4e2f39788c43d624a2d032e779778c9632d877afe218ae55ca294a666e755d95
diff --git a/dev-libs/libQtOlm/libQtOlm-3.0.1.ebuild b/dev-libs/libQtOlm/libQtOlm-3.0.1.ebuild
new file mode 100644
index 0000000..675679e
--- /dev/null
+++ b/dev-libs/libQtOlm/libQtOlm-3.0.1.ebuild
@@ -0,0 +1,41 @@
+
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+DESCRIPTION="A Qt wrapper for libolm"
+HOMEPAGE="https://gitlab.com/b0/libQtOlm"
+
+inherit eutils cmake-utils
+
+SRC_URI="https://gitlab.com/b0/libqtolm/-/archive/v3.0.1/libqtolm-v3.0.1.tar.gz"
+
+if [[ ${PV} == 9999 ]]
+then
+ EGIT_REPO_URI="https://gitlab.com/b0/${PN}.git"
+ EGIT_COMMIT="v${PV}"
+ inherit git-r3
+else
+ SRC_URI="https://gitlab.com/b0/libqtolm/-/archive/v${PV}/libqtolm-v${PV}.tar.gz"
+
+ KEYWORDS="~amd64 ~x86"
+fi
+
+LICENSE="GPL-3"
+SLOT="0"
+IUSE=""
+
+RDEPEND=""
+DEPEND="${RDEPEND}
+ dev-qt/qtcore
+ dev-libs/olm"
+
+S="${WORKDIR}"/libqtolm-v3.0.1
+
+src_configure() {
+ local mycmakeargs=(
+ -DBUILD_SHARED_LIBS=ON
+ )
+ cmake-utils_src_configure
+}
diff --git a/dev-libs/libQtOlm/libQtOlm-9999.ebuild b/dev-libs/libQtOlm/libQtOlm-9999.ebuild
new file mode 100644
index 0000000..9c4f18d
--- /dev/null
+++ b/dev-libs/libQtOlm/libQtOlm-9999.ebuild
@@ -0,0 +1,32 @@
+
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+DESCRIPTION="A Qt wrapper for libolm"
+HOMEPAGE="https://gitlab.com/b0/libQtOlm"
+
+inherit eutils cmake-utils git-r3
+
+SRC_URI=""
+EGIT_REPO_URI="https://gitlab.com/b0/${PN}.git"
+if [[ ${PV} != "9999" ]]; then
+ EGIT_COMMIT="v${PV}"
+ KEYWORDS="~amd64 ~x86"
+fi
+
+LICENSE="GPL-3"
+SLOT="0"
+IUSE=""
+
+RDEPEND=""
+DEPEND="${RDEPEND}
+ dev-qt/qtcore
+ dev-libs/olm"
+src_configure() {
+ local mycmakeargs=(
+ -DBUILD_SHARED_LIBS=ON
+ )
+ cmake-utils_src_configure
+}
diff --git a/dev-libs/libQtOlm/metadata.xml b/dev-libs/libQtOlm/metadata.xml
new file mode 100644
index 0000000..097975e
--- /dev/null
+++ b/dev-libs/libQtOlm/metadata.xml
@@ -0,0 +1,4 @@
+
+
+
+
diff --git a/dev-libs/libQuotient/Manifest b/dev-libs/libQuotient/Manifest
new file mode 100644
index 0000000..1a9afc8
--- /dev/null
+++ b/dev-libs/libQuotient/Manifest
@@ -0,0 +1,3 @@
+DIST libQuotient-0.6_beta1.tar.gz 549192 BLAKE2B e91e08bb2cfe8b369d79ae9d4514c15097042d74510d8d7428c25c12b635974fb637a126e4d87f34f9913f7d65ea14c5b83a5ebc2ed57039dc9fb884112e03bc SHA512 255560ee9a827ce140291859c9a7d11c718094b38a06e4555539aeda055daacd6a354e6685d67991fbbf2b407ab92b12986b854c27b81cfddb7b9b26c0e80e04
+EBUILD libQuotient-0.6_beta1.ebuild 840 BLAKE2B 2c57c4d8d6fe552e06f6885d608a1bf1ef793fd7ee36a3e06cf9379a2dba2ac1fc88eddc5f309b53d14012ee6727aeb401446c0ef4f27fea24968f45aebd8138 SHA512 51cd109d36b1cdb4c7759eb88b2d1fcea58c5d6de95767f848a2c767ed6a280d8b57565301c4024977ccfd0038c3b733d92fe3aa7ad165930af358837326ec4e
+EBUILD libQuotient-9999.ebuild 741 BLAKE2B dffbd0703ea438013e2be79d7a934e39ea463cb63b59f7db5c89f40b8dded85fd047b4aa685a21396756715285d6527eead8e50e9405042f7bd3a000a08d39c2 SHA512 c2a1fc3c33f8aac3c20d8495348b86ce58bffb65a8ce8c8ef9b985a141955ff0f624dd6a4b3c6de0a1d1c6a5ecef439c782bfb91f05c9aa05704fc13544eca61
diff --git a/dev-libs/libQuotient/libQuotient-0.6_beta1.ebuild b/dev-libs/libQuotient/libQuotient-0.6_beta1.ebuild
new file mode 100644
index 0000000..044d8b4
--- /dev/null
+++ b/dev-libs/libQuotient/libQuotient-0.6_beta1.ebuild
@@ -0,0 +1,39 @@
+
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+DESCRIPTION="A Qt5 library to write cross-platform clients for Matrix"
+HOMEPAGE="https://github.com/qmatrixclient/libqmatrixclient"
+
+inherit eutils cmake-utils
+
+#https://github.com/quotient-im/libQuotient/archive/0.6-beta1.tar.gz
+if [[ ${PV} == "9999" ]];
+then
+ EGIT_REPO_URI="https://github.com/quotient-im/${PN}.git"
+ inherit git-r3
+else
+ SRC_URI="https://github.com/quotient-im/libQuotient/archive/${PV}.tar.gz -> ${P}.tar.gz"
+KEYWORDS="~amd64 ~x86"
+fi
+
+LICENSE="GPL-3"
+SLOT="0"
+IUSE=""
+
+RDEPEND=""
+DEPEND="${RDEPEND}
+ dev-qt/qtcore
+ dev-qt/qtmultimedia
+ !!dev-libs/libqmatrixclient"
+
+S="${WORKDIR}"/${PN}-${PV/_/\-}
+
+src_configure() {
+ local mycmakeargs=(
+ -DBUILD_SHARED_LIBS=ON
+ )
+ cmake-utils_src_configure
+}
diff --git a/dev-libs/libQuotient/libQuotient-9999.ebuild b/dev-libs/libQuotient/libQuotient-9999.ebuild
new file mode 100644
index 0000000..3f82e11
--- /dev/null
+++ b/dev-libs/libQuotient/libQuotient-9999.ebuild
@@ -0,0 +1,37 @@
+
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+DESCRIPTION="A Qt5 library to write cross-platform clients for Matrix"
+HOMEPAGE="https://github.com/qmatrixclient/libqmatrixclient"
+
+inherit eutils cmake-utils
+
+if [[ ${PV} == "9999" ]]; then
+ inherit git-r3
+
+ SRC_URI=""
+ EGIT_REPO_URI="https://github.com/quotient-im/${PN}.git"
+else
+ SRC_URI="https://github.com/quotient-im/${PN}/archive/${PV}.tar.gz -> ${P}.tar.gz"
+ KEYWORDS="~amd64 ~x86"
+fi
+
+LICENSE="GPL-3"
+SLOT="0"
+IUSE=""
+
+RDEPEND=""
+DEPEND="${RDEPEND}
+ dev-qt/qtcore
+ dev-qt/qtmultimedia
+ !!dev-libs/libqmatrixclient"
+
+src_configure() {
+ local mycmakeargs=(
+ -DBUILD_SHARED_LIBS=ON
+ )
+ cmake-utils_src_configure
+}
diff --git a/dev-libs/libQuotient/metadata.xml b/dev-libs/libQuotient/metadata.xml
new file mode 100644
index 0000000..097975e
--- /dev/null
+++ b/dev-libs/libQuotient/metadata.xml
@@ -0,0 +1,4 @@
+
+
+
+
diff --git a/dev-libs/olm/Manifest b/dev-libs/olm/Manifest
new file mode 100644
index 0000000..6ac40a5
--- /dev/null
+++ b/dev-libs/olm/Manifest
@@ -0,0 +1,2 @@
+DIST olm-3.1.4.tar.bz2 461540 BLAKE2B fa69b1543330c5da37c04227b51197ba57968ef24def40df621b85c0988eac91f8a155f600ab26849f2cd213059c97c7035be6dcca0943245cd4e4895da314b3 SHA512 87265d835ca7332d162bd3573dffdd09c8337c464dd673f100db9193e8ea4cedd8cb2a92cf2c34ad1b552a55bbbce8f87a47559ccfba03fa69b32fc7ff07f5f0
+EBUILD olm-3.1.4.ebuild 549 BLAKE2B 93f47ec43a74ab46ce279d22a351e3cda22564fd17477f71d7b8098248cb6b950e4947d44b63d0885e8cbc10f4e8e9b609947030ab96dbeb3edb6a75d0b8fbeb SHA512 9f1c089a2dd4c89c34eb11d2448d83246bf903ca83f62f2e064ef0ec0602a6510436ab932e78f59cfe743d0bce552e38ac4e120179f8ffac5f9ba68f8a8cb58d
diff --git a/dev-libs/olm/metadata.xml b/dev-libs/olm/metadata.xml
new file mode 100644
index 0000000..097975e
--- /dev/null
+++ b/dev-libs/olm/metadata.xml
@@ -0,0 +1,4 @@
+
+
+
+
diff --git a/dev-libs/olm/olm-3.1.4.ebuild b/dev-libs/olm/olm-3.1.4.ebuild
new file mode 100644
index 0000000..3117eec
--- /dev/null
+++ b/dev-libs/olm/olm-3.1.4.ebuild
@@ -0,0 +1,21 @@
+ # Copyright 1999-2019 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit cmake-utils
+
+DESCRIPTION="An implementation of the Double Ratchet cryptographic ratchet in C++"
+HOMEPAGE="https://git.matrix.org/git/olm/about/"
+
+if [[ "${PV}" == 9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://gitlab.matrix.org/matrix-org/${PN}.git"
+else
+ SRC_URI="https://gitlab.matrix.org/matrix-org/${PN}/-/archive/${PV}/${P}.tar.bz2"
+ KEYWORDS="~amd64 ~x86"
+fi
+
+LICENSE="GPL-3"
+SLOT="0/$(ver_cut 1)"
+IUSE="debug"
diff --git a/net-im/spectral/Manifest b/net-im/spectral/Manifest
new file mode 100644
index 0000000..0daa680
--- /dev/null
+++ b/net-im/spectral/Manifest
@@ -0,0 +1,2 @@
+DIST 36befddf5d57faad990e72c88c5844794f274145.zip 133452 BLAKE2B 24d94c68bf97f5e0bf986f7024bcef1a61d1bd0e6f27108f386139fe6bc3515faad87cf4d825b94a3c3254ae75a82e4292a49f0fdaf5115e13c1e6a21af64dc1 SHA512 5bcaa4463e9ea033b3b51ec0524daf0350693a8d2a54a7784fc7109c957c0952d924c95b5cb36d9a9facc10d0ee9e9008d14743f23fe744964b5daa8050d8534
+DIST spectral-854.tar.gz 846106 BLAKE2B 6dc95d52f0acff646e6114e85c16dc9881edbc96eda1168094a477ef3b23d459c9d77aeedbd317cfa225317a9a83cd089539ccafff76df2da3104ef457034b20 SHA512 c8e5c65829a6fae07371461da1f91f33c01194db43a72dda5a35492bcd23595b5270f578494835ca484f9d9de24ab264754fb28f3483fd8ba4c190540416a0cd
diff --git a/net-im/spectral/metadata.xml b/net-im/spectral/metadata.xml
new file mode 100644
index 0000000..097975e
--- /dev/null
+++ b/net-im/spectral/metadata.xml
@@ -0,0 +1,4 @@
+
+
+
+
diff --git a/net-im/spectral/spectral-854.ebuild b/net-im/spectral/spectral-854.ebuild
new file mode 100644
index 0000000..2e62396
--- /dev/null
+++ b/net-im/spectral/spectral-854.ebuild
@@ -0,0 +1,77 @@
+# Copyright 2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+DESCRIPTION="A glossy client for Matrix, written in QtQuick Controls 2 and C++."
+HOMEPAGE="https://gitlab.com/spectral-im/spectral"
+
+inherit cmake-utils
+
+COMMON_URI="https://github.com/oKcerG/SortFilterProxyModel/archive/36befddf5d57faad990e72c88c5844794f274145.zip"
+
+
+
+if [[ ${PV} == 9999 ]]
+then
+ EGIT_REPO_URI="https://gitlab.com/b0/spectral.git"
+ inherit git-r3
+else
+ SRC_URI="https://gitlab.com/spectral-im/spectral/-/archive/${PV}/${P}.tar.gz
+ ${COMMON_URI}"
+
+ KEYWORDS="~amd64"
+fi
+
+LICENSE="GPL-3"
+SLOT="0"
+IUSE=""
+
+RDEPEND="
+ app-text/cmark
+ dev-qt/qtdeclarative
+ dev-qt/qtgui
+ dev-qt/qtmultimedia[qml]
+ dev-qt/qtwidgets
+ >=dev-qt/qtquickcontrols2-5.12
+ >=dev-libs/libQuotient-0.6_beta1
+ dev-libs/libQtOlm
+ dev-libs/qtkeychain
+ || ( media-fonts/roboto media-fonts/noto )
+ dev-qt/qtsvg
+"
+
+DEPEND="
+ ${RDEPEND}
+ >=dev-qt/qtcore-5.12
+"
+
+
+
+src_prepare() {
+ move_lib() {
+ local IN_DIR="${1}"
+ local OUT_DIR
+ [ -z "${2}" ] && OUT_DIR="${IN_DIR}" || OUT_DIR="${2%/}/${IN_DIR}"
+ mv "${WORKDIR}/${IN_DIR}"*/* "${S}/${OUT_DIR}" || die
+ }
+
+
+ local thirdparty_libs=" SortFilterProxyModel"
+ for thirdparty_lib in ${thirdparty_libs} ; do
+ move_lib "${thirdparty_lib}" include
+ done
+
+
+ cmake-utils_src_prepare
+}
+
+
+
+pkg_postinst() {
+ xdg_icon_cache_update
+}
+
+pkg_postrm() {
+ xdg_icon_cache_update
+}
diff --git a/net-im/spectral/spectral-9999.ebuild b/net-im/spectral/spectral-9999.ebuild
new file mode 100644
index 0000000..820f414
--- /dev/null
+++ b/net-im/spectral/spectral-9999.ebuild
@@ -0,0 +1,47 @@
+
+# Copyright 2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+DESCRIPTION="A glossy client for Matrix, written in QtQuick Controls 2 and C++."
+HOMEPAGE="https://gitlab.com/b0/spectral"
+
+inherit eutils cmake-utils git-r3
+EGIT_REPO_URI="https://gitlab.com/b0/spectral.git"
+EGIT_SUBMODULES=("include/SortFilterProxyModel")
+if [[ ${PV} != "9999" ]]; then
+ EGIT_COMMIT="${PV}"
+ KEYWORDS="~amd64 ~x86"
+fi
+
+LICENSE="GPL-3"
+SLOT="0"
+IUSE=""
+
+RDEPEND="
+ app-text/cmark
+ dev-qt/qtdeclarative
+ dev-qt/qtgui
+ dev-qt/qtmultimedia[qml]
+ dev-qt/qtwidgets
+ >=dev-qt/qtquickcontrols2-5.12
+ >=dev-libs/libQuotient-0.6_beta1
+ dev-libs/libQtOlm
+ dev-libs/qtkeychain
+ || ( media-fonts/roboto media-fonts/noto )
+ dev-qt/qtsvg
+"
+
+DEPEND="
+ ${RDEPEND}
+ >=dev-qt/qtcore-5.12
+"
+
+pkg_postinst() {
+ xdg_icon_cache_update
+}
+
+pkg_postrm() {
+ xdg_icon_cache_update
+}